"use strict";
/* eslint-disable */
/* tslint:disable */
/*
 * ---------------------------------------------------------------
 * ## THIS FILE WAS GENERATED VIA SWAGGER-TYPESCRIPT-API        ##
 * ##                                                           ##
 * ## AUTHOR: acacode                                           ##
 * ## SOURCE: https://github.com/acacode/swagger-typescript-api ##
 * ---------------------------------------------------------------
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.Accounts = void 0;
class Accounts {
    constructor(http) {
        /**
         * No description
         *
         * @tags accounts
         * @name GetAccount
         * @summary Get account
         * @request GET:/accounts/{address}
         * @response `200` `Account` Returns the latest account core data resource.
         * @response `400` `(AptosError)`
         * @response `404` `(AptosError)`
         * @response `500` `(AptosError)`
         */
        this.getAccount = (address, params = {}) => this.http.request(Object.assign({ path: `/accounts/${address}`, method: "GET", format: "json" }, params));
        /**
         * No description
         *
         * @tags accounts
         * @name GetAccountResources
         * @summary Get account resources
         * @request GET:/accounts/{address}/resources
         * @response `200` `(AccountResource)[]` This API returns account resources for a specific ledger version (AKA transaction version). If not present, the latest version is used. The Aptos nodes prune account state history, via a configurable time window (link). If the requested data has been pruned, the server responds with a 404
         * @response `400` `(AptosError)`
         * @response `404` `(AptosError)`
         * @response `500` `(AptosError)`
         */
        this.getAccountResources = (address, query, params = {}) => this.http.request(Object.assign({ path: `/accounts/${address}/resources`, method: "GET", query: query, format: "json" }, params));
        /**
         * No description
         *
         * @tags accounts
         * @name GetAccountModules
         * @summary Get account modules
         * @request GET:/accounts/{address}/modules
         * @response `200` `(MoveModule)[]` This API returns account modules for a specific ledger version (AKA transaction version). If not present, the latest version is used. The Aptos nodes prune account state history, via a configurable time window (link). If the requested data has been pruned, the server responds with a 404
         * @response `400` `(AptosError)`
         * @response `404` `(AptosError)`
         * @response `500` `(AptosError)`
         */
        this.getAccountModules = (address, query, params = {}) => this.http.request(Object.assign({ path: `/accounts/${address}/modules`, method: "GET", query: query, format: "json" }, params));
        /**
         * No description
         *
         * @tags transactions
         * @name GetAccountTransactions
         * @summary Get account transactions
         * @request GET:/accounts/{address}/transactions
         * @response `200` `(OnChainTransaction)[]` Returns on-chain transactions, paginated.
         * @response `400` `(AptosError)`
         * @response `500` `(AptosError)`
         */
        this.getAccountTransactions = (address, query, params = {}) => this.http.request(Object.assign({ path: `/accounts/${address}/transactions`, method: "GET", query: query, format: "json" }, params));
        /**
         * @description This API extracts event key from the account resource identified by the `event_handle_struct` and `field_name`, then returns events identified by the event key.
         *
         * @tags events
         * @name GetEventsByEventHandle
         * @summary Get events by event handle
         * @request GET:/accounts/{address}/events/{event_handle_struct}/{field_name}
         * @response `200` `(Event)[]` Returns events
         * @response `400` `(AptosError)`
         * @response `404` `(AptosError)`
         * @response `500` `(AptosError)`
         */
        this.getEventsByEventHandle = (address, eventHandleStruct, fieldName, params = {}) => this.http.request(Object.assign({ path: `/accounts/${address}/events/${eventHandleStruct}/${fieldName}`, method: "GET", format: "json" }, params));
        this.http = http;
    }
}
exports.Accounts = Accounts;
//# sourceMappingURL=Accounts.js.map