import { Event, HexEncodedBytes } from "./data-contracts";
import { HttpClient, RequestParams } from "./http-client";
export declare class Events<SecurityDataType = unknown> {
    http: HttpClient<SecurityDataType>;
    constructor(http: HttpClient<SecurityDataType>);
    /**
     * No description
     *
     * @tags events
     * @name GetEventsByEventKey
     * @summary Get events by event key
     * @request GET:/events/{event_key}
     * @response `200` `(Event)[]` Returns events
     * @response `400` `(AptosError)`
     * @response `404` `(AptosError)`
     * @response `500` `(AptosError)`
     */
    getEventsByEventKey: (eventKey: HexEncodedBytes, params?: RequestParams) => Promise<import("axios").AxiosResponse<Event[], any>>;
}
//# sourceMappingURL=Events.d.ts.map